<?php

/**
 * log actions.
 *
 * @package    regalias
 * @subpackage log
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class logActions extends sfQuery {

    protected $table_names = array(
        'NO_LOG',
        'NO_MAE_BD',
        'NO_OPE_BD',
        'INTERCEROS',
        'CREDENCIAL'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_MAE_BD,LEFT' =>
        array(
            'id_mae_bd' => 'NO_LOG'
        ),
        'NO_OPE_BD,LEFT' =>
        array(
            'id_ope_db-id_ope_bd' => 'NO_LOG'
        ),
        'INTERCEROS,LEFT' =>
        array(
            'id_mae_ter' => 'NO_LOG'
        ),
        'CREDENCIAL,LEFT' =>
        array(
            'comando' => 'NO_LOG'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_LOG' =>
        array(
            'id_log' => 'id_log',
            'id_tabla' => 'id_tabla',
            'id_anho' => 'id_anho',
            'id_ope_db' => 'id_ope_db',
            'id_mae_bd' => 'id_mae_bd',
            'id_mae_ter' => 'id_mae_ter',
            'usuario' => 'usuario',
            'fecha_log' => 'fecha_log',
            'comando' => 'comando',
            'observacion' => 'observacion',
            'ip_address' => 'ip_address'
        ),
        'NO_MAE_BD' =>
        array(
            'des_mae_bd' => 'des_mae_bd'
        ),
        'NO_OPE_BD' =>
        array(
            'des_ope_bd' => 'des_ope_bd'
        ),
        'INTERCEROS' =>
        array(
            'razon_soc' => 'razon_soc',
            'num_doc' => 'num_doc',
        ),
        'CREDENCIAL' =>
        array(
            'nombre' => 'funcionalidad'
        )
    );
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * BETWEENFECHA - para filtrar entre fechas y no tener encuenta la hora - ejemplo: where to_char(campo, 'YYYY-MM-DD') between x and y
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'INTERCEROS' =>
        array(
            'num_doc' => array('=' => array('num_doc'))
        ),
        'NO_LOG' =>
        array(
            'id_log' => array('!=' => array(-1)),
            'id_tabla' => array('=' => array('noRegistro')),
            'id_anho' => array('=' => array('id_anhos')),
            'id_ope_db' => array('=' => array('id_ope_bd')),
            'id_mae_bd' => array('=' => array('id_mae_bd')),
            'id_mae_ter' => array('=' => array('id_mae_ter')),
            'fecha_log' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'usuario' => array('=' => array('usuario')),
            'comando' => array('=' => array('comando_informe')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'NO_LOG' =>
        array(
            'observacion' => array('LIKEALLPLUS' => array('observacion', '%'))
        )
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_log'
    ); //campos para el ordenamiento de la consulta

    /*
     * Variables manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
